# -*-coding:utf-8 -*- #
# --------------------------------------------------------------------------
# ProjectName: protest
# FileName: request_method.py
# Author: xiao tian
# Datetime: 2025/5/10 15:18
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# --------------------------------------------------------------------------

import requests

from APIAutoTest_v3test import log_decorator
from APIAutoTest_v3test.common.db import DB
from APIAutoTest_v3test.common.read_system_ini import ReadSystemIni


class RequestMethod:
    # @log_decorator
    def __init__(self):
        login_url = ReadSystemIni().get_host("host") + "/auth"
        login_data = {
            "username": "admin",
            "password": "fWwO5OcV0c5AZfgOohpm4OE/FjKMc5wcjjaJvfbnrTIQMG5d3htn2aFA2iZGkSgYZ+9liGgmple6bCp+NT4PnY2Jlov8tV8Q/+nn2IZTuPCMwHqRrUchpPUr4wXWuQ+Gk55DNu4CZgxWQ5HxfzixGHJT29D6TUiz5Ea+mLm3fg8="
          }
        self.session = requests.sessions.Session()
        self.header = {"Authorization": "Bearer "+self.session.request(method="post",url=login_url,json=login_data).json().get("token")}
        self.session.headers.update(self.header)

        self.db = DB()

    @log_decorator
    def request_all(self,req_method, req_url, req_mime, case_data, sql_type, sql_data, update_key):
        # 先执行sql语句---该删除的就删除，如果有查询就需要更新用例数据，更新时，需要注意用例数据的类型
        if  sql_type =="delete":
            self.db.delete(sql_data)

        elif sql_type == "select":
            select_result = self.db.select(sql_data)
            if isinstance(case_data,str):
                case_data=case_data.replace(update_key,select_result)
            else:
                case_data[update_key]= select_result

        elif sql_type =="delete|select" or sql_type == "select|delete":
            self.db.delete(sql_data["delete"])
            select_result = self.db.select(sql_data["select"])
            if isinstance(case_data, str):
                case_data = case_data.replace(update_key, select_result)
            else:
                case_data[update_key] = select_result

        # 后发送请求--判断媒体类型，不同的媒体类型使用不同的关键字传参
        if req_mime =="json" or req_mime =="application/json":
            self.session.headers["content-type"] = "application/json"
            if isinstance(case_data,str) :
                return self.session.request(method=req_method,url=req_url,data=case_data)
            else:
                return self.session.request(method=req_method,url=req_url,json=case_data)
        elif req_mime =="text" or req_mime =="text/plain":
            self.session.headers["content-type"] = "text/plain"
            return self.session.request(method=req_method,url=req_url,data=case_data)

        elif req_mime =="form" or req_mime =="x-www-form-urlencoded" or req_mime == "application/x-www-form-urlencoded":
            self.session.headers["content-type"] = "application/x-www-form-urlencoded"
            return self.session.request(method=req_method,url=req_url,data=case_data)

        elif req_mime =="query":
            return self.session.request(method=req_method,url=req_url,params=case_data)

        elif req_mime == "query|json" or req_mime == "json|query":
            body = case_data.get("body")
            query = case_data.get("query")
            self.session.headers["content-type"] = "application/json"
            if isinstance(case_data, str):
                return self.session.request(method=req_method, url=req_url, data=body, params=query)
            else:
                return self.session.request(method=req_method, url=req_url, json=body, params=query)


        elif req_mime is None:
            return self.session.request(method=req_method,url=req_url)

        elif req_mime =="multipart/form-data" or req_mime == "form-data":
            return requests.request(method=req_method,url=req_url,files = case_data,headers=self.header)

        else:
            raise ValueError("媒体类型的错误")



if __name__ == '__main__':
    req = RequestMethod()
    print(type(req), req)